Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_routines_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4727)
@@ -154,4 +154,8 @@
 &                   'revap_ilp 131')
        enddo
+#ifdef ISOTRAC
+     call iso_verif_traceur(zxtrfl_ancien(1,i), &
+&           'iso_revap_fisrtilp 158: debut')
+#endif
 #endif
     endif !if (zrfln(i).gt.ridicule*1e-2) then  
@@ -193,4 +197,8 @@
         endif !if (zq(i).gt.ridicule) then
      endif !if ((iso_HDO.gt.0.and.(iso_O18.gt.0) then
+#ifdef ISOTRAC
+     call iso_verif_traceur(zxtrfl_ancien(1,i), &
+&           'iso_revap_fisrtilp 201: debut quand pas de precip')
+#endif
 !     write(*,*) 'iso_routines tmp 184'
 #endif               
@@ -504,5 +512,5 @@
 !             stop
   endif
-  enddo
+  enddo !do iiso=1,niso
 enddo !do i=1,ncas_evap_liq
 #endif          
@@ -514,6 +522,8 @@
 &       izone,zqevfl(1),Exi(1,1),fac_fluxtomixratio(1), &
 &       xtrevap_tag(1,1),1,hdiag(1))
+        ! dans cette routine, zxtrfl reçoit zxtrfln_cas
 
   enddo !do izone=1,ntraceurs_zone
+
 #ifdef ISOVERIF
 do i=1,ncas_evap_liq
@@ -522,4 +532,6 @@
 &              0.0,'revap_ilp 414')
 enddo
+     call iso_verif_traceur(zxtrfl(1,cas_evap_liq(i)), &
+&           'iso_revap_fisrtilp 470a: apres stewart_explicite_vectall')
 enddo !do i=1,ncas
 #endif            
@@ -536,6 +548,8 @@
      call iso_verif_traceur(zxt(1,cas_evap_liq(i)), &
 &           'iso_revap_fisrtilp 282')
+     call iso_verif_traceur(zxtrfl(1,cas_evap_liq(i)), &
+&           'iso_revap_fisrtilp 804a')
      call iso_verif_traceur(zxtrfln(1,cas_evap_liq(i)), &
-&           'iso_revap_fisrtilp 804')
+&           'iso_revap_fisrtilp 804b')
      do ixt=1,ntraciso
         call iso_verif_positif_choix(zxt(ixt,cas_evap_liq(i)), &
@@ -676,9 +690,6 @@
    if (iso_HDO.gt.0) then
       do i=1,ncas_evap_glace
-         if (zrfln_cas(i).gt.ridicule_rain) then
-                call iso_verif_aberrant( &
-&                  (zxtrfln_cas(iso_HDO,i) &
-&                 /zrfln_cas(i)), 'iso_revap_fisrtilp 4563')
-         endif
+                call iso_verif_aberrant_choix(zxtrfln_cas(iso_HDO,i), zrfln_cas(i), &
+                  ridicule_rain,deltalim_snow, 'iso_revap_fisrtilp 4563')
        enddo !do i=1,ncas_evap_glace
    endif !if ((iso_HDO.gt.0).and.(ixt.eq.iso_HDO)) then
@@ -789,6 +800,8 @@
      call iso_verif_traceur(zxt(1,cas_evap_glace(i)), &
 &           'iso_revap_fisrtilp 1033')
+     call iso_verif_traceur(zxtrfl(1,cas_evap_glace(i)), &
+&           'iso_revap_fisrtilp 1035a')
      call iso_verif_traceur(zxtrfln(1,cas_evap_glace(i)), &
-&           'iso_revap_fisrtilp 1035')
+&           'iso_revap_fisrtilp 1035b')
   enddo
 #endif          
@@ -830,5 +843,7 @@
     call iso_verif_traceur(zxt(1,i),'iso_revap_fisrtilp 532')
     call iso_verif_traceur(zxtrfln(1,i), &
-&           'iso_revap_fisrtilp 533') 
+&           'iso_revap_fisrtilp 533a') 
+    call iso_verif_traceur(zxtrfl(1,i), &
+&           'iso_revap_fisrtilp 533b')
     do ixt=1,ntraciso
         call iso_verif_positif_choix(zxt(ixt,i),0.0, &
@@ -836,5 +851,5 @@
     enddo
 enddo !do i=1,klon
-        write(*,*) 'revap_ilp 814: sortie'
+        !write(*,*) 'revap_ilp 814: sortie'
 #endif       
 #endif          
@@ -2384,12 +2399,12 @@
     endif !if (iso_eau.gt.0) then
     if (abs(evap(i)).gt.ridicule_rain) then
-      if (iso_HDO.gt.0) then                  
-         if (iso_verif_aberrant_nostop(xtevap(iso_HDO,i)/evap(i), &
-&           'iso_surf>iso_rosee_givre 3193').eq.1) then    
+      if (iso_HDO.gt.0) then                      
+         if (iso_verif_aberrant_choix_nostop(xtevap(iso_HDO,i),evap(i), &
+&           ridicule_rain,deltalim_snow,'iso_surf>iso_rosee_givre 3193').eq.1) then    
                 write(*,*) 'zxtalphai(iso_HDO)=',zxtalphai(iso_HDO)
                 write(*,*) 'deltaD1eff=',deltaD(xt1lay(iso_HDO,i)/q1lay(i))
                 write(*,*) 'tsurf(i)=',tsurf(i)
                 write(*,*) 'q1lay(i)=',q1lay(i)   
-                stop  
+                !stop  
            endif !if (iso_verif_aberrant_nostop
       endif  !if (iso_HDO.gt.0) then  
@@ -2534,5 +2549,5 @@
 
 ! quelques verifs de bilan d'eau
-#ifdef ISOVERIF      
+#ifdef ISOVERIF   
 do il=1,ncas
   do ixt=1,niso
@@ -2647,7 +2662,5 @@
 &             'stewart_explicite_vectall 220')
     enddo
-#endif
-#ifdef ISOVERIF
-      if (iso_eau.gt.0) then
+    if (iso_eau.gt.0) then
         call iso_verif_egalite_choix( &
 &              (Exi(iso_eau,il)*fac_ftmr(il)), &
@@ -2669,9 +2682,5 @@
 &                   *fac_ftmr(il))),'stewart_explicite 214')
        endif !if ((iso_HDO.gt.0).and.
-       if ((debug.eq.1).and.(il.eq.il_debug)) then
-           write(*,*) 'stewart_explicit 224: cas Pqisup<=0'
-           write(*,*) 'Eqi(il),deltaD=',Eqi(il), &
-&                   deltaD((Exi(iso_HDO,il)/Eqi(il)))
-       endif
+
 #endif              
 else !if (Pqisup.eq.0) then
@@ -2679,5 +2688,5 @@
 h(il)=qeff(il)/qs(il)       
 h(il)= MAX(MIN(h(il),1.0),0.0)
-#ifdef ISOVERIF        
+#ifdef ISOVERIF
 call iso_verif_positif(h(il)-thumxt1,'stewart_explicit 209') 
 #endif        
@@ -2739,5 +2748,5 @@
       endif !if ((iso_HDO.gt.0).and.
     endif !if (iso_HDO.gt.0) then
-    if ((debug.eq.1).and.(il.eq.il_debug)) then
+    if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
            write(*,*) 'stewart_explicit 302: cas evap~0'
            write(*,*) 'deltaDv est inchangé:',deltaD( &
@@ -2779,5 +2788,5 @@
 f(il)=m(il)/m0(il)    
 ! verifs
-#ifdef ISOVERIF        
+#ifdef ISOVERIF       
 call iso_verif_positif((m(il)), &
 &           'stewart_explicite 173')
@@ -2836,9 +2845,7 @@
     ! rajout verif 4 sept 2009
     if (iso_HDO.gt.0) then
-     if (Pqisup(il).gt.ridicule) then
-        call iso_verif_aberrant((Rl0(iso_HDO,il)), &
-&                   'stewart_explicite 368')
-     endif
-    endif
+        call iso_verif_aberrant_choix(Rl0(iso_HDO,il)*Pqisup(il),Pqisup(il), &
+&                   ridicule_rain,deltalim_snow,'stewart_explicite 368')
+    endif !if (iso_HDO.gt.0) then
   endif !(iso_eau.gt.0)
 #endif
@@ -2868,6 +2875,4 @@
 &                   'stewart_explicite 271')
    enddo !do ixt=1,niso   
-#endif
-#ifdef ISOVERIF  
    if (iso_eau.gt.0) then
       call iso_verif_egalite_choix( &
@@ -2923,5 +2928,5 @@
        endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
      endif !if (iso_HDO.gt.0)
-     if ((debug.eq.1).and.(il.eq.il_debug)) then
+     if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 442: tout se réévapore'
          write(*,*) 'Eqi(il),deltaD=',Eqi(il), &
@@ -2943,7 +2948,4 @@
 if ((h(il).gt.0.99).or. &
 &           (h(il).gt.0.98).and.(f(il).lt.1e-3)) then
-#ifdef ISOVERIF          
-!            write(*,*) 'stewart_explicit 191: cas h=1: il=',il
-#endif            
     do ixt=1,niso
     interm(ixt,il)=alphap(ixt,il)*(1.0-h(il)) &
@@ -2981,6 +2983,4 @@
 &           'stewart_explicite 261')
     enddo !do ixt=1,niso
-#endif           
-#ifdef ISOVERIF
     if (iso_eau.gt.0) then
         call iso_verif_egalite_choix( &
@@ -3007,8 +3007,6 @@
       
      if (iso_HDO.gt.0) then 
-       if (Pqiinf(il).gt.ridicule_rain) then
-           if (iso_verif_aberrant_nostop( &
-&                  (Pxtiinf(iso_HDO,il)/Pqiinf(il)), &
-&                   'stewart_explicie 248').eq.1) then
+       if (iso_verif_aberrant_choix_nostop(Pxtiinf(iso_HDO,il),Pqiinf(il), &
+&                ridicule_rain,deltalim_snow,'stewart_explicite 248').eq.1) then
              write(*,*) 'cas reeq totale, il=',il
              write(*,*) 'deltaDl0=',deltaD( &
@@ -3019,6 +3017,5 @@
 &                   (Rb(iso_hdo,il)))
              stop
-           endif 
-       endif  !if ((iso_HDO.gt.0).and.(ixt.eq.iso_HDO).and.
+       endif !if (iso_verif_aberrant_choix_nostop
        if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
          call iso_verif_aberrant(( &
@@ -3027,5 +3024,5 @@
        endif !if ((iso_HDO.gt.0).and.
      endif  !if (iso_HDO.gt.0) then
-    if ((debug.eq.1).and.(il.eq.il_debug)) then
+     if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 526: cas h~1: rééq'
          write(*,*) 'Eqi(il),deltaD=',Eqi(il), &
@@ -3034,10 +3031,10 @@
 &                   (Rb0(iso_hdo,il))),deltaD( &
 &                   (Rl0(iso_hdo,il)))
-    endif 
+     endif !if ((debug.eq.1).and.(il.eq.il_debug)) then
 #endif
     ! end verifs
 
 else if ((f(il).gt.0.998).and. &
-&           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il))) then
+&           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il))) then ! if ((h(il).gt.0.99).or. 
 
 !*** cas particulier pour éviter imprécisions numériques:
@@ -3083,6 +3080,4 @@
 &           'stewart_explicite 397')
    enddo !do ixt=1,niso 
-#endif
-#ifdef ISOVERIF
    if (iso_eau.gt.0) then
         call iso_verif_egalite_choix( &
@@ -3167,7 +3162,7 @@
            stop
          endif !if (iso_verif_aberrant_nostop((
-       endif !if ((iso_HDO.gt.0).and.
+       endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
      endif !!if ((iso_HDO.gt.0)
-     if ((debug.eq.1).and.(il.eq.il_debug)) then
+     if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 663: cas où réévap faible'
          write(*,*) 'ordre 1 pour la vapeur et le liquide'
@@ -3271,5 +3266,5 @@
              endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
           endif !if ((iso_HDO.gt.0)
-     if ((debug.eq.1).and.(il.eq.il_debug)) then
+     if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 767: cas de réévap sèche'
          write(*,*) 'distill de Rayleigh'
@@ -3317,6 +3312,4 @@
 &                   'stewart_explicite 467')
     enddo !do ixt=1,niso    
-#endif          
-#ifdef ISOVERIF  
           if (iso_eau.gt.0) then
             call iso_verif_egalite_choix( &
@@ -3360,5 +3353,5 @@
             endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
           endif !if (iso_HDO.gt.0)
-      if ((debug.eq.1).and.(il.eq.il_debug)) then
+      if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 831: flux de masse vap~0'
          write(*,*) 'Eqi(il),deltaD=',Eqi(il), &
@@ -3429,5 +3422,5 @@
         enddo !do ixt=1,niso    
 #endif
-#ifdef ISOVERIF   
+#ifdef ISOVERIF
           if (iso_eau.gt.0) then
             call iso_verif_egalite_choix( &
@@ -3546,5 +3539,5 @@
         enddo !do ixt=1,niso 
 #endif
-#ifdef ISOVERIF      
+#ifdef ISOVERIF   
           if (iso_eau.gt.0) then
             call iso_verif_egalite_choix( &
@@ -3750,6 +3743,5 @@
        ! pour meilleure convergence numérique:
        !xtnew=qp0+Eqi*fac_ftmr
-   endif   ! if (iso_eau.gt.0).and.(ixt.eq.iso_eau)    
-
+   endif   ! if (iso_eau.gt.0).and.(ixt.eq.iso_eau)  
    if (iso_HDO.gt.0) then
      if (Pqiinf(il).gt.ridicule_rain) then
@@ -3778,13 +3770,13 @@
 &                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il) &
 &                   *fac_ftmr(il))),'stewart_explicite 912')
-        endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
-      endif !if (iso_HDO.gt.0)
-      if ((debug.eq.1).and.(il.eq.il_debug)) then
+       endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
+       if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
          write(*,*) 'stewart_explicit 991: fcas général'
          write(*,*) 'mais avec formule simplifiée'
-         write(*,*) 'il,Eqi(il),deltaD=',il,Eqi(il), &
-&                   deltaD((Exi(iso_HDO,il)/Eqi(il)))
-      endif
-#endif     
+         write(*,*) 'il,Eqi(il)=',il,Eqi(il)
+         write(*,*) 'deltaD=',deltaD((Exi(iso_HDO,il)/Eqi(il)))
+       endif
+      endif !if (iso_HDO.gt.0)  
+#endif
   ! end verifs  
     
@@ -3838,5 +3830,5 @@
 ! compression
 if (ncas_Jsimple+ncas_rieman.gt.0) then
-!#ifdef ISOVERIF          
+!#ifdef ISOVERIF         
 !        write(*,*) 'stewart_explicite_vectall 873:compression_calculJ' 
 !#endif        
@@ -3927,33 +3919,7 @@
     ! ******* traitement vectoriel du cas Rieman (=2533)
 if (ncas_rieman.gt.0) then
-!#ifdef ISOVERIF
-!!          write(*,*) 'traitement vectoriel rieman: x',ncas_rieman
-!          do icas_rieman=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
-!!            write(*,*) 'ntot_cas(icas_rieman)=',ntot_cas(icas_rieman)
-!          call iso_verif_positif(float(ntot_cas(icas_rieman))-1.0,
-!     :           'stewart_expl 984: ntot faux') 
-!          enddo   !do icas_rieman=1,ncas_rieman       
-!#endif            
+            
    icas_rieman=1+ncas_Jsimple
-!           write(*,*) 'stewart_expl 988 tmp: icas_rieman=',icas_rieman
-!           write(*,*) 'qp0_cas(1)=',qp0_cas(1)
-!           write(*,*) 'A_cas(1)=',A_cas(1)
-!           write(*,*) 'm0_cas(1)=',m0_cas(1)
-!           write(*,*) 'm_cas(1)=',m_cas(1)
-!           if (iso_eau.gt.0) then
-!           write(*,*) 'beta_cas(iso_eau,1)=',beta_cas(iso_eau,1)
-!           write(*,*) 'gama_cas(iso_eau,1)=',gama_cas(iso_eau,1)
-!           endif
-!           write(*,*) 'f_cas(1)=',f_cas(1)
-!           write(*,*) 'g_cas(1)=',g_cas(1)
-!#ifdef rieman           
-!           call integrale_rieman_vectall
-!     :       (ncas_rieman,m_cas(icas_rieman),
-!     :       J(1,icas_rieman),e(1,icas_rieman),
-!     :       qp0_cas(icas_rieman),A_cas(icas_rieman),
-!     :       m0_cas(icas_rieman),beta_cas(1,icas_rieman),
-!     :       gama_cas(1,icas_rieman),f_cas(icas_rieman),
-!     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
-!#else
+
    call integrale_gauss_vectall &
 &       (ncas_rieman,m_cas(icas_rieman), &
@@ -3964,22 +3930,4 @@
 !     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
 &       g_cas(icas_rieman))      
-!#endif
-!#ifdef ISOVERIF
-!           do il=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
-!             do ixt=1,niso
-!               call integrale_Rieman_precision(m_cas(il),m0_cas(il),
-!     :          Jtmp,etmp,ntot_cas(il)*1e2,
-!     :           qp0_cas(il),A_cas(il),m0_cas(il),
-!     :          beta_cas(ixt,il),gama_cas(ixt,il),f_cas(il),g_cas(il))
-!               call iso_verif_egalite_choix((Jtmp),
-!     :           (J(ixt,il)),
-!     :           'stewart_exp 999: test rieman',errmax,errmaxrel)
-!               if ((iso_eau.gt.0).and.(ixt.eq.iso_eau)) then
-!                 write(*,*) 'stew exp tmp 1005: il,J(iso_eau,il),Jtmp=',
-!     :           il,J(iso_eau,il),Jtmp
-!               endif
-!             enddo             
-!           enddo
-!#endif           
 
   endif !if (ncas_rieman.gt.0) then
@@ -4008,33 +3956,4 @@
 &          -beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il) &
 &                   /g_cas(il)/g_cas(il))
-!#ifdef ISOVERIF            
-!            if ((iso_eau.gt.0).and.(iso_eau.eq.ixt)) then
-!              write(*,*) 'stewart_explicite tmp 1071: il=',il
-!              if (il.le.ncas_Jsimple) then
-!                write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
-!              else !if (il.le.ncas_Jsimple) then
-!                write(*,*) 'cas_rieman(il)=',cas_rieman(il)
-!              endif !if (il.le.ncas_Jsimple) then
-!              write(*,*) 'f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)=',
-!     :                   f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)
-!              write(*,*) 'g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)=',
-!     ;          g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)
-!              write(*,*) 'A_cas(il)=',A_cas(il)
-!              write(*,*) 'pond Rl0=',(f_cas(il)**beta_cas(ixt,il))
-!     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)))
-!     :          +beta(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
-!     :                   /f_cas(il)/g_cas(il)
-!              write(*,*) 'pond Rb0=',gama_cas(ixt,il)*beta_cas(ixt,il)
-!     :                   *r_jl0(ixt,il)/f_cas(il)/g_cas(il)
-!              write(*,*) 'pondRl0=fac1*fac2+t3'
-!              write(*,*) 'fac1=',
-!     :           f_cas(il)**beta_cas(ixt,il)
-!              write(*,*) 'fac2=',
-!     :             g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)) 
-!              write(*,*) 't3=',
-!     :           beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
-!     :                   /f_cas(il)/g_cas(il)     
-!            endif
-!#endif
 
     Pxtiinf_cas(ixt,il)=Pqiinf_cas(il)*Rl(ixt,il) 
@@ -4097,5 +4016,5 @@
     enddo
 #endif
-#ifdef ISOVERIF            
+#ifdef ISOVERIF         
     if (iso_eau.gt.0) then
       if (iso_verif_egalite_choix_nostop( &
@@ -4411,7 +4330,6 @@
    if (iso_HDO.gt.0) then
     if (Pqiinf(il).gt.ridicule_rain) then
-      if (iso_verif_aberrant_nostop( &
-&                  (Pxtiinf(iso_HDO,il)/Pqiinf(il)), &
-&                   'stewart_explicie 871').eq.1)  then
+      if (iso_verif_aberrant_choix_nostop(Pxtiinf(iso_HDO,il),Pqiinf(il),ridicule_rain,deltalim_snow, &
+&                   'stewart_explicite 871').eq.1)  then
       write(*,*) 'deltaDl0=',deltaD( &
 &           (Rl0(iso_HDO,il)))
@@ -4428,5 +4346,5 @@
     endif !if (iso_HDO.gt.0)
 
-    if ((debug.eq.1).and.(il.eq.il_debug)) then
+    if ((debug.eq.1).and.(il.eq.il_debug).and.(Eqi(il).gt.0.)) then
           write(*,*) 'stewart_explicit 1558: cas avec calcul J'
           write(*,*) 'Eqi(il),deltaD=',Eqi(il), &
@@ -4478,5 +4396,5 @@
 
 #ifdef ISOVERIF
-!          write(*,*) 'stewart_explicite vectall 1179: fin'
+          write(*,*) 'stewart_explicite vectall 1179: fin'
 #endif         
 
@@ -4702,9 +4620,7 @@
 &           'stewart_sublim_nofrac 39')              
 endif !if ((iso_eau.gt.0).and.(ixt.eq.iso_eau)) then
-if ((iso_HDO.gt.0).and. &
-&           (Pqisup(il).gt.ridicule_rain)) then
-    call iso_verif_aberrant( &
-&           (Pxtisup(iso_HDO,il)/Pqisup(il)), &
-&           'stewart_sublim_nofrac 40')     
+if (iso_HDO.gt.0) then ! Camille 9 mars 2023: moins stricte pour condensat
+    call iso_verif_aberrant_choix(Pxtisup(iso_HDO,il),Pqisup(il), &
+&           ridicule_rain,deltalim_snow, 'stewart_sublim_nofrac 40') 
 endif !if ((iso_HDO.gt.0).and.(ixt.eq.iso_HDO).and.
 enddo !do il=1,ncas
@@ -4834,9 +4750,7 @@
         enddo ! do ixt=1,niso
         ! verif que deltaD(Pqiinf) raisonable
-        if ((iso_HDO.gt.0).and. &
-     &           (Pqiinf(il).gt.ridicule_rain)) then
-            call iso_verif_aberrant( &
-     &           (Pxtiinf(iso_HDO,il)/Pqiinf(il)), &
-     &           'stewart_sublim 175')
+        if (iso_HDO.gt.0) then
+            call iso_verif_aberrant_choix(Pxtiinf(iso_HDO,il),Pqiinf(il), &
+     &           ridicule_rain,deltalim_snow, 'stewart_sublim 175')
         endif !if ((iso_HDO.gt.0).and.(ixt.eq.iso_HDO).and.
         if (iso_eau.gt.0) then
@@ -4923,6 +4837,4 @@
 !         integer ntot_cas(ncas)
          integer il,ixt        
-         integer coeff_precision
-         parameter (coeff_precision=0.2)
 
 
@@ -10827,5 +10739,5 @@
      &          Exi_cas(1,1),Exi(1,1), &
 #endif       
-     &          xtp_avantevaptrac_cas,0,hdiag(1)) ! hdiag ne sera pas utilisé
+     &          xtp_avantevaptrac_cas,0,hdiag(1)) ! hdiag ne sera pas utilise
 
        enddo ! do izone=1,ntraceurs_zone
@@ -12615,5 +12527,5 @@
                   if (iso_verif_aberrant_choix_nostop( &
      &               zxtliq(iso_HDO,i),cond(i), &
-     &               ridicule,deltalim, &
+     &               ridicule,deltalim_snow, &
      &               'condiso_liq_ice_vectall 32b').eq.1) then
                     write(*,*) 'deltaDvap=',deltaD(xt(iso_hdo,i)/qt(i))
@@ -12636,5 +12548,5 @@
                         write(*,*) 'deltaO18(zxtliq/cond)=',deltaO(zxtliq(iso_O18,i)/cond(i))
                         write(*,*) 'tcond(i)=',tcond(i)-t_coup,'°C'
-                        stop
+                        !stop ! Camille 9 mars 2023: trop strict
                     endif  !if (iso_verif_O18_aberrant_nostop(     
                     endif ! if (iso_O18.gt.0) then      
@@ -12714,5 +12626,5 @@
                         write(*,*) 'zxtalphai(iso_O18,i)=',zxtalphai(iso_O18,i)
                         write(*,*) 'xt(1:niso,i)=',xt(1:niso,i)
-                        stop
+                        !stop ! Camille 9 mars 2023: trop strict
                     endif  !if (iso_verif_O18_aberrant_nostop(     
                     endif ! if (iso_O18.gt.0) then
@@ -12765,5 +12677,7 @@
           if (zfice(i).gt.0.9) then
               if (iso_verif_aberrant_choix_nostop( &
-     &          zxtice(iso_HDO,i),cond(i),ridicule,deltalim_snow, &
+     &          zxtice(iso_HDO,i),cond(i),ridicule,deltalim_snow, & 
+                ! Camille 9 mars 2023: pour le condensat, on laisse plus de
+                ! marge
      &          'condiso_liq_ice_vect 412').eq.1) then
                 write(*,*) 'debug condiso_liq_ice_vect 449: i,zfice=', &
@@ -13470,5 +13384,8 @@
           endif !if (iso_eau.gt.0) then
 #ifdef ISOTRAC
-          call iso_verif_traceur(xtsnow_evap(1,i), &
+!          call iso_verif_traceur(xtsnow_evap(1,i), &
+!     &           'gestion neige 2146') ! attention car snow_evap parfois
+!     négatif -> il ne faut pas passer dans les verifs de positivité.
+          call iso_verif_traceur_justmass(xtsnow_evap(1,i), &
      &           'gestion neige 2146')
 #endif          
@@ -14141,6 +14058,6 @@
         if (iso_HDO.gt.0) then
             call iso_verif_aberrant_choix(-xtsol_evap(iso_HDO,i), &
-     &           sol_evap(i),ridicule_evap,deltalim, &
-     &           'calcul_iso_surf_sic 257')
+     &           sol_evap(i),ridicule_evap,deltalim_snow, &
+     &           'calcul_iso_surf_sic 257_sol_evap')
         endif
 #endif            
@@ -14162,8 +14079,6 @@
               endif !if (iso_eau.gt.0) then
               if (iso_HDO.gt.0) then
-                if (evap(i).gt.ridicule_evap) then  
-                   call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i), &
-     &                  'calcul_iso_surf_sic 257')
-               endif !if (evap(i).gt.ridicule_evap) then  
+                   call iso_verif_aberrant_choix(xtevap(iso_HDO,i),evap(i), &
+     &                  ridicule_evap,deltalim_snow,'calcul_iso_surf_sic 257_evap')
               endif !if (iso_eau.gt.0) then
 #ifdef ISOTRAC
@@ -14323,11 +14238,16 @@
         enddo !do i=1,knon
         endif !if (iso_HDO.gt.0) then
-        
-        if (iso_eau.gt.0) then  
+            
         do i=1,knon
+        if (iso_eau.gt.0) then
           call iso_verif_egalite_choix(xtsnow(iso_eau,i),snow(i),  &
-     &         'calcul_iso_surf_lic_vectall 587',errmax,errmaxrel)
-        enddo
+     &         'calcul_iso_surf_lic_vectall 587a',errmax,errmaxrel)
         endif
+        if (iso_HDO.gt.0) then
+          call iso_verif_aberrant_choix(xtsnow(iso_HDO,i), &
+     &               snow(i),ridicule_snow,deltalim_snow, &
+     &               'calcul_iso_surf_lic 587b')
+        endif
+        enddo !do i=1,knon
 #endif             
         
@@ -14476,16 +14396,10 @@
      &                  'calcul_iso_surf_lic 363',errmax,errmaxrel)  
               endif !if (iso_eau.gt.0) then
-              if (iso_HDO.gt.0) then  
-                if (snow(i).gt.ridicule_snow) then  
-                 call iso_verif_aberrant(xtsnow(iso_HDO,i)/snow(i), &
-     &                  'calcul_iso_surf_lic 367')
-                endif !if (snow(i).gt.ridicule_snow) then 
+              if (iso_HDO.gt.0) then   
                 call iso_verif_aberrant_choix(xtsnow(iso_HDO,i), &
-     &               snow(i),ridicule,deltalim_snow, &
+     &               snow(i),ridicule_snow,deltalim_snow, &
      &               'calcul_iso_surf_lic 797') 
-                if (abs(evap(i)).gt.ridicule_evap) then  
-                 call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i), &
-     &                  'calcul_iso_surf_lic 369')
-                endif ! if (evap(i).gt.ridicule_evap) then 
+                call iso_verif_aberrant_choix(xtevap(iso_HDO,i),evap(i), &
+     &                  ridicule_evap,deltalim_snow, 'calcul_iso_surf_lic 369')
               endif !if (iso_eau.gt.0) then
 #ifdef ISOTRAC
@@ -15795,8 +15709,6 @@
               endif !if (iso_eau.gt.0) then
               if (iso_HDO.gt.0) then  
-                 if (snow(i).gt.ridicule_snow) then 
-                    call iso_verif_aberrant(xtsnow(iso_HDO,i)/snow(i), &
-     &                  'calcul_iso_surf_ter 749')
-                 endif !if (snow(i).gt.ridicule_snow) then
+                 call iso_verif_aberrant_choix(xtsnow(iso_HDO,i),snow(i), &
+     &                  ridicule_snow,deltalim_snow, 'calcul_iso_surf_ter 749')
                  call iso_verif_aberrant_choix(xtsnow(iso_HDO,i), &
      &               snow(i),ridicule,deltalim_snow, &
@@ -15809,7 +15721,7 @@
                      write(*,*) 'sol_evap,snow_evap=', &
      &                   sol_evap(i),snow_evap(i)
-                     write(*,*) 'deltaDsol_evap=', &
+                     if (sol_evap(i).gt.ridicule_evap)write(*,*) 'deltaDsol_evap=', &
      &                   deltaD(xtsol_evap(iso_hdo,i)/sol_evap(i))
-                     write(*,*) 'deltaDsnow_evap=', &
+                     if (snow_evap(i).gt.ridicule_evap)write(*,*) 'deltaDsnow_evap=', &
      &                   deltaD(xtsnow_evap(iso_hdo,i)/snow_evap(i))
                      write(*,*) 'deltaD1new=',deltaD( &
@@ -16094,8 +16006,6 @@
           endif !if (iso_eau.gt.0) then
           if (iso_HDO.gt.0) then
-            if (snow(i,nsrf).gt.ridicule_snow) then
-            call iso_verif_aberrant(xtsnow(iso_hdo,i,nsrf)/snow(i,nsrf), &
-     &                'phyisoetat0 117')
-            endif
+            call iso_verif_aberrant_choix(xtsnow(iso_hdo,i,nsrf),snow(i,nsrf), &
+     &                ridicule_snow, deltalim_snow, 'phyisoetat0 117')
           endif !if (iso_eau.gt.0) then
         enddo !do nsrf=1,nbsrf
@@ -16180,6 +16090,4 @@
         real deltaD_snow_fall_O18,deltaD_rain_fall_O18
         real alpha(niso),kcin(niso)
-        real q0,h0
-        parameter (q0=20e-3,h0=0.7)
 !      character*50 text
         
@@ -16314,8 +16222,7 @@
         do k=1,klev
           do ixt=1,niso
-           RMerlivat(ixt)=toce(ixt)/alpha(ixt) &
-     &                  *(1-kcin(ixt))/(1.0-kcin(ixt)*h0)
-           xt_ancien(ixt,i,k)=q_ancien(i,k)*RMerlivat(ixt) &
-     &                  *(min(q0,q_ancien(i,k))/q0)**(alpha(ixt)-1.0)
+           call iso_init_ideal(q_ancien(i,k),xt_ancien(ixt,i,k),ixt, &
+                alpha(ixt),kcin(ixt),toce(ixt))
+
            if (q_ancien(i,k).gt.ridicule) then
            xtl_ancien(ixt,i,k)=ql_ancien(i,k)*alpha(ixt) &
@@ -16338,24 +16245,24 @@
      &           'phyisoetat0 16067')  
         enddo !do ixt=1,niso
-        if ((k.eq.1).and.(iso_HDO.gt.0).and.(iso_O18.gt.0) &
-                .and.(abs(q_ancien(i,k)-q0).lt.1e-3)) then
-                ! vérifier qu'on est proche de la fermeture de Merlivat
-            write(*,*) 'i,k=',i,k
-            write(*,*) 'q_ancien(i,k)=',q_ancien(i,k)
-            write(*,*) 'deltaD=',deltaD(xt_ancien(iso_HDO,i,k)/q_ancien(i,k))
-            write(*,*) 'deltaDM=',deltaD(RMerlivat(iso_HDO))
-            write(*,*) 'deltaO=',deltaO(xt_ancien(iso_O18,i,k)/q_ancien(i,k))
-            write(*,*) 'deltaOM=',deltaO(RMerlivat(iso_O18))
-            write(*,*) 'dexcess=',dexcess(xt_ancien(iso_HDO,i,k)/q_ancien(i,k), &
-                    xt_ancien(iso_O18,i,k)/q_ancien(i,k))
-            write(*,*) 'dexcessM=',dexcess(RMerlivat(iso_HDO),RMerlivat(iso_O18))
-            write(*,*) 'kcin=',kcin
-            write(*,*) 'toce=',toce
-            write(*,*) 'alpha=',alpha
-            call iso_verif_positif(20.0-abs(-80.0-deltaD(xt_ancien(iso_HDO,i,k)/q_ancien(i,k))), &
-                    'phyisoetat0 16398a')   
-            call iso_verif_positif(5.0-abs(10.0-dexcess(xt_ancien(iso_HDO,i,k)/q_ancien(i,k), &
-                    xt_ancien(iso_O18,i,k)/q_ancien(i,k))),'phyisoetat0 16398b') 
-        endif 
+
+        ! Camille 7 mars 2023: ajout d'un check
+        if ((i.eq.1).and.(k.eq.1).and.(iso_HDO.gt.0)) then
+        write(*,*) 'phyisoetat0 16362: q_ancien(1,1)=',q_ancien(1,1) 
+        write(*,*) 'deltaD_ancien=',deltaD(xt_ancien(iso_HDO,i,k)/q_ancien(i,k))
+        write(*,*) 'xt_ancien(:,i,k)=',xt_ancien(:,i,k)
+        endif !if ((i.eq.1).and.(k.eq.1)) then
+
+        if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then 
+            if (q_ancien(i,k).gt.ridicule) then  
+               if (iso_verif_o18_aberrant_nostop( &
+     &              xt_ancien(iso_HDO,i,k)/q_ancien(i,k), &
+     &              xt_ancien(iso_O18,i,k)/q_ancien(i,k), &
+     &              'phyisoetat0 16366 q_ancien').eq.1) then
+                  write(*,*) 'phyisoetat0 16367: i,k,q_ancien(i,k)=',i,k,q_ancien(i,k) 
+                  write(*,*) 'xt_ancien(:,i,k)=',xt_ancien(:,i,k)
+                  stop
+              endif !  if (iso_verif_o18_aberrant_nostop 
+            endif !if (q_seri(i,k).gt.errmax) then  
+        endif !if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then 
 #endif 
 
@@ -16543,5 +16450,5 @@
    CHARACTER(LEN=2) :: str2
    CHARACTER(LEN=5) :: str5
-   CHARACTER(LEN=maxlen) :: outiso, oldIso, modname, nam(2)
+   CHARACTER(LEN=maxlen) :: outiso, oldIso, modname, nam(3), oldIso2
    REAL :: xmin, xmax
    LOGICAL :: found
@@ -16559,11 +16466,17 @@
       outiso = isoName(ixt)
       oldIso = strTail(new2oldH2O(outiso), '_')            !--- Remove "H2O_" from "H2O_<iso>[_<tag>]"
+      i = INDEX(outiso, '_', .TRUE.)
+      oldIso2 = outiso(1:i-1)//outiso(i+1:LEN_TRIM(outiso)) ! CR 2023: on ajoute cette possibilité aussi, elle correspond au cas le plus récent.
+!      write(*,*) 'tmp 16541:'
+!      write(*,*) 'outiso=',outiso
+!      write(*,*) 'oldIso=',oldIso
+!      write(*,*) 'oldIso2=',oldIso2
+
       ! on lit seulement si ixt<=niso ou si on initialise les traceurs d'après fichier:
 #ifdef ISOTRAC
       IF(ixt <= niso .OR. initialisation_isotrac == 0) THEN
 #endif
-      found = phyetat0iso_srf3(xtsnow,      "XTSNOW", "Surface snow", 0.)
-      if (.NOT.found) CALL abort_physic('isotopes_routines_mod', 'phyiso_etat0_fichier 16581: unfound isotopic variable',1)
       found = phyetat0iso_srf3(fxtevap,     "XTEVAP", "evaporation",  0.)
+      if (.NOT.found) CALL abort_physic('isotopes_routines_mod', 'phyiso_etat0_fichier 16581a: unfound isotopic variable',1)
       found = phyetat0iso_get2(xtrain_fall, "xtrain_f", "xrain fall", 0.)
       found = phyetat0iso_get2(xtsnow_fall, "xtsnow_f", "xsnow fall", 0.)
@@ -16571,5 +16484,4 @@
       found = phyetat0iso_get3(xtl_ancien,  "XTLANCIEN", "QLANCIEN",  0.)
       found = phyetat0iso_get3(xts_ancien,  "XTSANCIEN", "QSANCIEN",  0.)
-      found = phyetat0iso_get2(xtrun_off_lic_0, "XTRUNOFFLIC0", "RUNOFFLIC0", 0.)
       found = phyetat0iso_get3(wake_deltaxt,  "WAKE_DELTAXT", "Delta hum. wake/env",  0.)
 #ifdef ISOVERIF
@@ -16580,5 +16492,4 @@
             DO nsrf = 1, nbsrf
                CALL iso_verif_egalite(fxtevap(iso_eau,i,nsrf),fevap(i,nsrf),TRIM(modname)//' 231c')
-               CALL iso_verif_egalite( xtsnow(iso_eau,i,nsrf), snow(i,nsrf),TRIM(modname)//' 231d')
             END DO
          END DO
